class LockSemaphore<S extends Semaphore> implements Lock {
    private final S s;
    LockSemaphore(S s){ 
        this.s = s;
        s.set(1);
    }
    public void lock() { s.acquire(); }
    public void unlock() { s.release(); }
}
